%% standardn qd-algoritmus na urceni prvku retezoveho zlomku (viz str. 25)
% vaze se k prikladu na str. 26
% author: Patrik Drda

clear
close all
clc
%%
n=20; % velikost qd-tabulky, cim vetsi, tim vice prvku retezoveho zlomku ziskame
a=zeros(1,n);
for i=1:n
    a(i)=1/factorial(i); % koeficienty rady
end
a=[1 a]; % pridani nuloveho clenu rady

qd=zeros(n);

%% algoritmus (viz str. 25)
    for r=1:n
        s=(-1)^r;
        if s==-1
            qd(r,2)=0;
        else
        qd(r,2)=a(r/2+1)/a(r/2);
        end
       
    end
 for c=3:n 
    for r=1:n
       s=(-1)^r;
       v=(-1)^c;
       if v==-1 && s==-1 && r>1
           qd(r,c)=qd(r+1,c-1)-qd(r-1,c-1)+qd(r,c-2);
       elseif v==1 && s==1 && r>2 && r<n
           qd(r,c)=(qd(r+1,c-1)/qd(r-1,c-1))*qd(r,c-2);
       else
               qd(r,c)=0;
               
           
       end
    end
 end
    
