
% funkce, ktera vrati koreny jmenovatele B_r,n
function [roots,R]=roots_method1(K,lambda_0,lambda_r,mu_r) % K=m+n nebo K=r+n, kde
% m... je pocatecni velikost populce, r... velikost populace v case


% tvorba matice ve tvaru (6.43) na str. 61
V=zeros(K,K);
     V(1,1)=lambda_0;
     V(2,2)=(lambda_r(1)+mu_r(1));
     V(2,1)=sqrt(lambda_0*mu_r(1));
     V(1,2)=sqrt(lambda_0*mu_r(1));
 for j=3:K
         
         V(j,j)=(lambda_r(j-1)+mu_r(j-1));
        
         V(j,j-1)=sqrt(lambda_r(j-2)*mu_r(j-1));
         V(j-1,j)=sqrt(lambda_r(j-2)*mu_r(j-1));
 end
 
 % hledani vlastnich cisel, plati: root = - vlastni cislo
   roots=  -eig(V);
   R=length(roots);